clear all; clc; close all;
 path('.\LibOSTT;',path);

rand('seed', 4243); randn('seed', 4243)
T = 1024*4; %choose 1024 * 7 for exact replication  of the ACF for the coarse-level aggregate process !!!!!!!!!!!!!!!!!!!!!!!!!
% J = log2(T); 
  J = log2(1024); burnin = 2^J; %it corresponds to the # of Wold coefficients used to reconstruct x_t

NREP = 50;  nLags = 70; ACFsimMSAR_FineLevel    = NaN(nLags+1,NREP); ACFtheoCOMPONENTS= NaN(nLags+1,J+1);
                        ACFsimMSAR_CoarseLevel  = NaN(nLags+1,NREP);  
                        ACFsimARMApq_CoarseLevel= NaN(nLags+1,NREP);
%  ccf figs 
LineWidth = 4; FontSize = 16; FontName = 'Helvetica';  % or 'Times' 

lambda = 1; % not really useful, maybe a better picture with lambda = 0.01 but that's it
sameShocksAtAllScales =1;
%---------------------- For Paper OSTT (2019) ----------------------------%
% MULTISCALETYPE = '2Persistent';
%----------------------- Fine-level Process ------------------------------%
                                             phi_x  = 0.7; theta_x= 0.0  ; SIGMA_x=1;  const_rescaling = 1; % very similar to the case where we set % psi_jkFine(jj)= 0; for jj>=Jstart
%----------------------- Coarse-level Process ----------------------------%
% postulate AR(1) at level of aggregation m=8 (try also m=16,32)        |--> legend(sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f, J=3',phi_x,phi), sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f, J=4',phi_x,phi),sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f, J=5',phi_x,phi)); ylim([0 1])
m=8; Joffset = log2(m); Jstart = log2(m)+1;  phi  = 0.9; theta= 0.0  ; SIGMA=1.0; 
%                                            phi  = 0.0; % For Figure 2 Panel A (only fine-level AR(1) model)
%                                         OR SIGMA=0;                           (only fine-level AR(1) model)
                                          
ny = (T-burnin)/m;
A = zeros(ny,T-burnin); %coarsening 'ny times nx' matrix
for rr=1:ny
    A(rr,(rr-1)*m+1:rr*m)= 1/m * ones(1,m);
end

%-------------------------------------------------------------------------%
psi_j0Coarse = NaN(1,J+1);   varjCoarse=zeros(1,J+1);
psi_j0Fine   = NaN(1,J+1);   varjFine  =zeros(1,J+1);
for jj=1:Jstart-1
      psi_j0Fine(jj) = (1+ ((phi_x+theta_x)/(1-phi_x)) *(1-2*phi_x^(2^(jj-1)-1)+phi_x^(2^jj -1)) )/sqrt(2^jj);
    psi_j0Coarse(jj) = 0;
end
for jj=Jstart:J
      psi_j0Fine(jj) = (1+ ((phi_x+theta_x)/(1-phi_x)) *(1-2*phi_x^(2^(jj-1        )-1)+phi_x^(2^jj          -1)) )/sqrt(2^jj) * const_rescaling;
      psi_j0Coarse(jj) = (1+ ((phi  +theta  )/(1-phi  )) *(1-2*  phi^(2^(jj-1-Joffset)-1)+ phi^(2^(jj-Joffset) -1)) )/sqrt(2^(jj-Joffset));
%     psi_j0Coarse(jj) = (1+ ((phi  +theta  )/(1-phi  )) *(1-2*  phi^(2^(jj-1-Joffset)-1)+ phi^(2^(jj-Joffset) -1)) )/sqrt(2^(jj)); %######
end
  psi_j0Fine(J+1)= (1+ ((phi_x+theta_x)/(1-phi_x)) *(1-phi_x^(2^J           -1)))/sqrt(2^J);
psi_j0Coarse(J+1)= (1+ ((phi  +theta  )/(1-phi  )) *(1-  phi^(2^(J-Joffset) -1)))/sqrt(2^(J-Joffset));
            
psi_jkCoarse = NaN(1,J+1);
psi_jkFine   = NaN(1,J+1);
for jj=1:Jstart-1
      psi_jkFine(jj) = ((phi_x+theta_x)/(1-phi_x))*((1-phi_x^(2^(jj-1)))^2)/(sqrt(2^jj)    ); %numerically stable
    psi_jkCoarse(jj) = 0;
end
for jj=Jstart:J
      psi_jkFine(jj) = ((phi_x+theta_x)/(1-phi_x))*((1-phi_x^(2^(jj-1        )))^2)/(sqrt(2^jj)    ) * const_rescaling;           %numerically stable
    psi_jkCoarse(jj) = ((phi  +theta  )/(1-phi  ))*((1-  phi^(2^(jj-1-Joffset)))^2)/(sqrt(2^(jj-Joffset))    ); %numerically stable
%   psi_jkCoarse(jj) = ((phi  +theta  )/(1-phi  ))*((1-  phi^(2^(jj-1-Joffset)))^2)/(sqrt(2^(jj        ))    ); %######
end
    psi_jkFine(J+1)= ((phi_x+theta_x)/(1-phi_x))*( 1-phi_x^(2^J          ))   /(sqrt(2^J)          ); %numerically stable
  psi_jkCoarse(J+1)= ((phi  +theta  )/(1-phi  ))*( 1-  phi^(2^(J-Joffset)))   /(sqrt(2^(J-Joffset))); %numerically stable
% psi_jkCoarse(J+1)= ((phi  +theta  )/(1-phi  ))*( 1-  phi^(2^(J-Joffset)))   /(sqrt(2^(J)));         %######
%-------------- construct vector of psi^{(j)}_k --------------------------%
        PSI_jkCoarse = NaN(T,J+1);
        PSI_jkFine   = NaN(T,J+1); 
        for jj=1:J
            Tss = length(dyad(J-jj)) * (T/2^J);
            %                    [psi_j0(jj)  psi_jk(jj )*((phi.^(2^jj *(1:T-1)    )];
              PSI_jkFine(:,jj) = [  psi_j0Fine(jj)    psi_jkFine(jj)* (phi_x.^(2^jj           *(1:T-1) -1))] ; %numerically stable 
                  varjFine(jj) = varjFine(jj) + sum(PSI_jkFine(:,jj).^2);
            if jj<Jstart
                PSI_jkCoarse(:,jj) = zeros(T,1);
            else
            PSI_jkCoarse(:,jj) = [psi_j0Coarse(jj)  psi_jkCoarse(jj)* (  phi.^(2^(jj-Joffset) *(1:T-1) -1))] ; %numerically stable
                varjCoarse(jj) = varjCoarse(jj) + sum(PSI_jkCoarse(:,jj).^2);
            end
            ACFtheoCOMPONENTS(:,jj) = acf([],[PSI_jkCoarse(1:Tss,jj)'],nLags);          %Compute ACF of the components from Wold Coefficients
        end
          PSI_jkFine(:,J+1)= [  psi_j0Fine(J+1)   psi_jkFine(J+1)* (phi_x.^(2^J           *(1:T-1) -1))];  %numerically stable
        PSI_jkCoarse(:,J+1)= [psi_j0Coarse(J+1) psi_jkCoarse(J+1)* (  phi.^(2^(J-Joffset) *(1:T-1) -1))];  %numerically stable
        varjFine(J+1)   = varjFine(J+1)   + sum(PSI_jkFine(:,J+1).^2);   %1/(1-phi_x^2)
        varjCoarse(J+1) = varjCoarse(J+1) + sum(PSI_jkCoarse(:,J+1).^2); %1/(1-phi^2)
%jj=1,2,3,4,5,6,7; [PSI_jkFine(1:10,jj) PSI_jkCoarse(1:10,jj+Joffset)]
%% (2) simulate scale-wise Extended Wold series 
clear psi_j0 psi_jk; varfromMSAR = 0; C=1; P=1; Q=3; parameters = zeros(C+P+Q,NREP);
for rep = 1:NREP
    rep
    mynoiseCoarse=randn(T,1); mynoiseFine=randn(T,1);
      mynoiseFine_components = RedundantHaar(J,mynoiseFine  ,1);   mynoiseFine_components = flipud(mynoiseFine_components);
    mynoiseCoarse_components = RedundantHaar(J,mynoiseCoarse,1); mynoiseCoarse_components = flipud(mynoiseCoarse_components); %from the most recent (T) to the oldest (1)
    if sameShocksAtAllScales ==1 
        mynoiseCoarse_components = mynoiseFine_components; % SAME SCHOCKS, it seems that nothing changes ...
    end
    
    xTSfromMSAR = zeros(T,1); xTSfromMSAR_components = zeros(T,J+1);
    for tt=T:-1:burnin+1
        for jj=1:J
            ScaledNoiseFine     =   mynoiseFine_components(T-tt+1:2^jj:end-burnin,jj) * sqrt(2^jj);
            ScaledNoiseCoarse   = mynoiseCoarse_components(T-tt+1:2^jj:end-burnin,jj) * sqrt(2^jj);
            if jj > Joffset
%           xTSfromMSAR_components(tt,jj) =     sum(PSI_jk(1:length(ScaledNoise),jj).* ScaledNoise);
            xTSfromMSAR(tt) = xTSfromMSAR(tt) + SIGMA  *sum(PSI_jkCoarse(1:length(ScaledNoiseCoarse),jj).* ScaledNoiseCoarse) + ...
                                                SIGMA_x*sum(  PSI_jkFine(1:length(ScaledNoiseFine  ),jj).* ScaledNoiseFine);
            else
            xTSfromMSAR(tt) = xTSfromMSAR(tt) + SIGMA  *sum(PSI_jkCoarse(1:length(ScaledNoiseCoarse),jj).* ScaledNoiseCoarse) + ...
                                                SIGMA_x*sum(  PSI_jkFine(1:length(ScaledNoiseFine  ),jj).* ScaledNoiseFine)   *lambda;
            end
        end
            %-------------------------- adding pi(t) ---------------------%
            ScaledNoiseFine     =   mynoiseFine_components(T-tt+1:2^jj:end-burnin,J+1)* sqrt(2^J);
            ScaledNoiseCoarse   = mynoiseCoarse_components(T-tt+1:2^jj:end-burnin,J+1)* sqrt(2^J);
%           xTSfromMSAR_components(tt,J+1) =    sum( PSI_jkCoarse(1:length(ScaledNoise),J+1).* ScaledNoise);
            xTSfromMSAR(tt) = xTSfromMSAR(tt) + SIGMA  *sum( PSI_jkCoarse(1:length(ScaledNoiseCoarse),J+1).* ScaledNoiseCoarse) + ...
                                                SIGMA_x*sum(   PSI_jkFine(1:length(ScaledNoiseFine)  ,J+1).* ScaledNoiseFine) *lambda; %[xTS xTSfromMSAR]
    end
    xTSfromMSAR_agg    = (A*xTSfromMSAR(burnin+1:end))   ; %the aggregate covariance matrix is CovAggr    = (A*Vx*A'); CovAggr./CovAggr(1,1)
    [ACFsimMSAR_FineLevel(:,rep)  , Lags, Bounds] = autocorr(xTSfromMSAR(burnin+1:end),nLags);
    [ACFsimMSAR_CoarseLevel(:,rep), Lags, Bounds] = autocorr(xTSfromMSAR_agg,nLags);
%     if rep==1
%         figure(2)
%         plot(xTSfromMSAR(burnin+1:end))
%         axis tight
%         save2pdf('xSimulated',1,600)
%     end
    varfromMSAR = varfromMSAR + var(xTSfromMSAR(burnin+1:end));
end
    acARMAPQ = acf(mean(parameters(2,:)),mean(parameters(3,:)),70);

        figure(3)    
        subplot(3,1,1)
        stem(Lags,(0.9).^(Lags),'r'); hold on;
        plot(Lags,mean(ACFsimMSAR_FineLevel,2),'b-x');  legend(sprintf('ACF AR(1) process with phi = %3.2f', 0.90), sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f',phi_x,phi)); xlabel('Lag'); %title('ACF'); 
        subplot(3,1,2)
        stem(Lags,(0.97).^(Lags),'r'); hold on;
        plot(Lags,mean(ACFsimMSAR_FineLevel,2),'b-x');  legend(sprintf('ACF AR(1) process with phi = %3.2f', 0.97), sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f',phi_x,phi)); xlabel('Lag'); %title('ACF');
        subplot(3,1,3)
        stem(Lags,(0.98).^(Lags),'r'); hold on;
        plot(Lags,mean(ACFsimMSAR_FineLevel,2),'b-x');  legend(sprintf('ACF AR(1) process with phi = %3.2f', 0.98), sprintf('ACF process z with rho_x=%3.2f, rho_y=%3.2f',phi_x,phi)); xlabel('Lag'); %title('ACF');
set(findall(gcf,'-property','FontSize'),'FontSize',45)
set(findall(gcf,'-property','MarkerSize'),'MarkerSize',15)

fprintf('Variance process simulated    from Multiscale Wold = %3.3f \n', varfromMSAR/NREP);
fprintf('Variance fine-level process   from Multiscale Wold = %3.3f \n', sum(varjFine));
fprintf('Variance coarse-level process from Multiscale Wold = %3.3f \n', sum(varjCoarse));