function [zzComponents, const, WoldCoeffEstimated, stdWoldInnovation] = ComputeWoldComponentsFromLP(z,nlags,Hmax, J)
% PURPOSE: Compute components from Wold decompositon
% 
% -----------------------------------------------------
% USAGE: [yyComponents, const] = ComputeWoldComponents(z,p,Hmax, J)
% where:
% z    = 
% p    = Compute shocks from VAR(p)
% Hmax =
% J    = number of components (actually J+1 since we have also \pi).
%  
% -----------------------------------------------------
% RETURNS: 
% yyComponents = the j-th column is associated with the j-th component, ordered as the shocks.
% const        =
% 
% WoldCoeffEstimated = 
% sum(yyComponents,2) ~ yy (original series)

[WoldCoeffEstimated_temp] = pirfGAUSS(z,nlags,Hmax);

%-------------------- Compute Wold Innovations ---------------------------%
[T,nvars]= size(z);          % sample size    %
% Generate the Dependent Variable Vector %%
yyVAR = z(nlags+1:T, :);
% Form the Regressors %%
xxVAR = ones(T-nlags,1);
for i = 1:nlags
    xxVAR = [xxVAR, z((nlags+1-i):(T-i),:)];    %"[]" : concatenation operator
end
% OLS on the VAR %%
betaVAR = (xxVAR'*xxVAR)\(xxVAR'*yyVAR); const = betaVAR(1);
% Get Structural Residuals %%
shocksEstimated = yyVAR - xxVAR*betaVAR;         %% Reduced form residuals 
stdWoldInnovation = std(shocksEstimated);
shocksEstimated = [NaN(nlags,nvars);shocksEstimated];    %% Padding to make it of the size as the original sample
clear xxVAR yyVAR

%-------------------------------------------------------------------------%
third_dim = size(WoldCoeffEstimated_temp,1)/nvars;
WoldCoeffEstimated = NaN(nvars,nvars,third_dim);
for hh=1:third_dim
    WoldCoeffEstimated(:,:,hh) = WoldCoeffEstimated_temp((hh-1)*nvars+1:hh*nvars,:);
end
%-------------------------------------------------------------------------%
[zzComponents] = ComputeMVWoldComponentsFromMA(WoldCoeffEstimated,shocksEstimated,J);