clear; close all; clc;
% Becnhmark is: yieldtype = 'GSW'; CpoVsPCA = 1; ComponentsOfPCAvsPCAOfComponents = 0
%-------------------------------------------------------------------------%
        load('.\YieldGSWDataSet.mat')  
        formatIn = 'dd-mm-yyyy';
        calM = NaN(size(dateMonthly,1),1);
        for tt=1:size(dateMonthly,1)
            DateString = num2str(dateMonthly(tt));
            DateString = strcat(DateString(7:8),'-',DateString(5:6),'-',DateString(1:4));
            calM(tt) = datenum(DateString,formatIn);
        end
clearvars -except calM yieldMonthly yieldtype

%%
% select maturities
  mats=[12  24    36    48    60          84               120];    % mats in months
yields          = yieldMonthly(   :,mats)/100; 
clearvars -except yields calM mats ss se yieldtype

T=length(yields);
prices=-(ones(T,1)*mats/12).*yields;

forwards = prices(:,1:4)-prices(:,2:5);

load CPoTrendForRebonato tau_CPI

hpr = prices(13:T,1:length(mats)-1)-prices(1:T-12,2:length(mats));
hprx = hpr - yields(1:T-12,1)*ones(1,  length(mats)-1);
hpr  = [zeros(12,1)*ones(1,length(mats)-1); hpr];
hprx = [zeros(12,1)*ones(1,length(mats)-1); hprx];
clear hpr prices 
J=6;
%-------------------------------------------------------------------------%
% compute level, slope and curvatore factors, and their components
CpoVsPCA = 1;
lvl = mean( yields(:, 2:end),2); lvl_components = RedundantHaar(J,lvl,1);  

slo = lvl - yields(:,1);         slo_components = RedundantHaar(J,slo,1);  
fprintf('Correlation between Level and Slope from Rebonato and CPo %3.3f \n', corr(lvl,slo))

%-------------------------------------------------------------------------%
% Eigenvalue decomposition for yields
   Vy = cov((yields(1:T,:))); 
   [Q,L] = eig(Vy);
   % this produces Q*L*Q' = Vy. The eigenvalues are not necessarily ordered.  
   % reorder with largest eigenvalue on top 
   [D,Indx] = sort(-diag(L));
   D = -D; 
   Q2 = Q(:,Indx); 
   L2 = diag(D,0); 
   Q = Q2; 
   L = L2; 

   PC=yields(:,1:end)*Q;  % principal components for forecasting
   % note that yields(beg:T,:)*Q are orthogonal, but YT*Q are a little bit shorter
   % so not exactly orthogonal in sample. Where possible, use 
   % PC = yields(beg:T,:)*Q
   level = PC(:,1);   
   slope = PC(:,2);
   curve = PC(:,3); 
      
   % for matrices x = Q'*yields
   % for time series: X = Y*Q
clear Vy Q L D Indx Q2 L2  
fprintf('Correlation between Level and Slope from PCA %3.3f \n', corr(level,slope))
if ~CpoVsPCA
    lvl = level;
    slo = slope;
end
clear level slope
%-------------------------------------------------------------------------%   
addpath('.\LibraryWoldComponents')
Hmax =  size(lvl,1)-1; % forecast horizon
p    =  24; 
  [WoldComponentsEstimated, const_yy] = ComputeWoldComponentsFromVAR([lvl        slo      ]          ,p,Hmax, J);
  lvl_components_WOLD = squeeze(WoldComponentsEstimated(:,1,:)); %clear WoldComponentsEstimated const_yy
  slo_components_WOLD = squeeze(WoldComponentsEstimated(:,2,:));  clear WoldComponentsEstimated const_yy

  [WoldComponentsEstimated, const_yy] = ComputeWoldComponentsFromVAR([yields        ]          ,p,Hmax, J);
  PCAlevel_Wold =                 squeeze(mean(WoldComponentsEstimated(:,2:end,:),2));     
  PCAslope_Wold = PCAlevel_Wold - squeeze(     WoldComponentsEstimated(:,1,:));     clear WoldComponentsEstimated const_yy

%----------------------- select sample of interest -----------------------%
  dates_ss=datenum(1971,09,30); [ss,~]=find(calM==dates_ss); 
% dates_ss=datenum(1985,01,31); [ss,~]=find(calM==dates_ss); % The mid-1980s start date avoids mixing different monetary policy regimes (Rudebusch and Wu, 2007)
  dates_se=datenum(2016,12,30); [se,~]=find(calM==dates_se);
clear dates_ss dates_se
disp([datestr(calM(ss)) ' ' datestr(calM(se))]); 

calM = calM(ss:se,:);
yields  = yields(  ss:se,:);
forwards= forwards(ss:se,:); Ts = size(forwards,1);

lvl  = lvl(ss:se);   lvl_components = lvl_components(ss:se,:); lvl_components_WOLD  = lvl_components_WOLD(ss:se,:); 
slo  = slo(ss:se);   slo_components = slo_components(ss:se,:); slo_components_WOLD  = slo_components_WOLD(ss:se,:); 


PCAlevel_Wold = PCAlevel_Wold(ss:se,:); % plot(detrend([sum(PCAlevel_Wold,2) lvl],0)); 
fprintf('Correlation between average of Wold components and component of average (=level) : %3.3f \n',corr(sum(PCAlevel_Wold,2),lvl))
PCAslope_Wold = PCAslope_Wold(ss:se,:); % plot(detrend([sum(PCAslope_Wold,2) slo],0)); 
fprintf('Correlation between L-S     of Wold components and component of L-S     (=slope) : %3.3f \n',corr(sum(PCAslope_Wold,2),slo))
%  pos_yield = 1; temp = ols(yields(:,pos_yield),[ones(size(yields,1),1) PCAlevel_Wold]       );
%  pos_yield = 1; temp = ols(yields(:,pos_yield),[ones(size(yields,1),1) PCAlevel_Wold(:,5:7)]); temp.rbar

tau_CPI = tau_CPI(ss:se,:);
lvlTC = ols(lvl,[ones(size(lvl,1),1) tau_CPI]); 
                     lvlT = lvlTC.yhat;lvlC = lvlTC.resid;
figure(3); plot([lvl lvlT              lvlC]);
%          plot([                      lvlC(1:end-12),sum(lvl_components(     1:end-12,2:5),2)])
%          plot([                      lvlC(1:end-12),sum(lvl_components_WOLD(1:end-12,2:5),2)])
clear lvlTC
sloTC = ols(slo,[ones(size(lvl,1),1) tau_CPI]); 
                     sloT = sloTC.yhat;sloC = sloTC.resid;                     
clear sloTC                     
hprx = hprx(ss:se,:);
clear ss se
T=length(yields);

% Compute PCA (average and slope) of Wold components of yields
    L_components_WOLD = PCAlevel_Wold;
    S_components_WOLD = PCAslope_Wold;
clear lvl_components_WOLD slo_components_WOLD PCAlevel_Wold PCAslope_Wold

info.bfmt = strvcat('%3.2f','%3.2f','%3.2f');
info.bfmt = '%3.2f';
info.sefmt = '(%3.2f)';
info.tfmt ='[%3.2f]';
info.ldum = 1;
% cnames = strvcat('Const','j=1','j=2','j=3','j=4','j=5','j=6','J=7');
% info.cnames = cnames;

[mean(hprx); std(hprx); mean(hprx)./std(hprx)]
% *************************************************************************
%%  Table 0 - regressions of excess returns of each bond on all forward rates
% *************************************************************************
disp('-----------------------------------------------------');
disp('TABLE 01 (CP) : returns on all forwards, (Panel C, row b)');

 HPRX = hprx(13:end,:);
AHPRX        = mean(HPRX                               ,2);
AHPRX_durstd = mean(HPRX./repmat(mats(2:end)/12,T-12,1),2);

  FT   = [ones(T-12,1) yields(1:T-12,1) forwards(1:T-12,:)];              % yields and forwards - 1964-2002
% FS   = [ones(T-12,1) 100*fs(1:T-12,:)];     % forward-spot spread
% YT   = [ones(T-12,1) 100*yields(1:end-12,:)];

% [betas_CP,stbetas_CP,R2_CP, R2adj_CP,v_CP,F_CP]             = olsgmm(HPRX,FT,12,0); % std errors: HH with 12 lags
  [betas_CP,stbetas_CP,R2_CP, R2adj_CP,v_CP,F_CP] = olsgmm(AHPRX,FT,18,1); % tests: NW with 18 lags
  BP_CP = [ones(T,1) yields(1:T,1) forwards(1:T,:)]*betas_CP;
bv_xr  = betas_CP';
tstat_xr=betas_CP'./stbetas_CP';
R2v_xr=R2adj_CP;
mprint3(bv_xr,tstat_xr,[NaN(1,5) R2v_xr'],info);
fprintf('\n\n')
clear betas_CP stbetas_CP R2_CP R2adj_CP v_CP F_CP bv_xr tstat_xr R2v_xr FT

% disp('TABLE 02 (CPo): returns on cycles, 1964-2016');
% Construct CPo factor
[betasCPo_1STEP,~,R2CPo_1STEP]             = olsgmm(yields,[ones(T,1) tau_CPI],12,0); 
ci = yields-[ones(T,1) tau_CPI]*betasCPo_1STEP; % cycles 
clear betasCPo_1STEP R2CPo_1STEP
c1   =      ci(:,1);
cbar = mean(ci(:,2:end),2);
clear  ci
CPo   = [ones(T-12,1) cbar(1:T-12,1) c1(1:T-12,:)];              % yields and forwards - 1964-2002
%   [betas_CPo,stbetas_CPo,R2_CPo, R2adj_CPo,~,F_CPo] = olsgmm(AHPRX,CPo,18,1); % tests: NW with 18 lags
% % [betas_CPo,stbetas_CPo,R2_CPo, R2adj_CPo,~,F_CPo] = olsgmm(AHPRX_durstd,CPo,18,1); % tests: NW with 18 lags
% BP_CPo = [ones(T,1) cbar(1:T,1) c1(1:T,:)]*betas_CPo;
% bv_xr  = betas_CPo';
% tstat_xr=betas_CPo'./stbetas_CPo';
% R2v_xr=R2adj_CPo;
% mprint3(bv_xr,tstat_xr,[NaN(1,2) R2v_xr'],info);
% fprintf('\n\n')
clear betas_CPo stbetas_CPo R2_CPo R2adj_CPo F_CPo bv_xr tstat_xr R2v_xr o CPo

% tests: NW with 18 lags
NWvsHH = 1 ; 
NWLags = 18;

% *************************************************************************
%% Table III - regressions of excess returns of each bond on ...
% *************************************************************************
disp('-----------------------------------------------------');
disp('Univariate regressions against Level and its Cycle (Panel A, row a AND Panel C, row c)');

% *************************************************************************
% REGR=[lvl(1:end-12) lvlT(1:end-12) lvlC(1:end-12) sum(lvl_components(    1:end-12,   2:    5),2)]; o = ones(T-12,1);
% REGR=[lvl(1:end-12) lvlT(1:end-12) lvlC(1:end-12) sum(L_components_WOLD(1:end-12,[1 2 3 4 5]),2)]; o = ones(T-12,1);
  REGR=[lvl(1:end-12) lvlT(1:end-12) lvlC(1:end-12) sum(L_components_WOLD(1:end-12,[1 2 3   5]),2)]; o = ones(T-12,1);
numREGR=(1:size(REGR,2));
   spec=[1 0 0 0; ... % Level
         0 0 1 0];    % Level Cycle

for s=1:size(spec,1)
  [betas,stbetas,~,R2adj]             = olsgmm(AHPRX,[o REGR(:,numREGR(spec(s,:)>0))],NWLags,NWvsHH); % std errors: HH with 12 lags

bv_xr  = betas';
tstat_xr=betas'./stbetas';
R2v_xr=R2adj;
mprint3(bv_xr,tstat_xr,[NaN(1,sum(spec(s,:))) R2v_xr'],info);
fprintf('\n\n')
end
clear betas stbetas R2 R2adj v F_trash bv_xr tstat_xr R2v_xr o spec REGR numREGR s

% *************************************************************************
% disp('-----------------------------------------------------');
% disp('Univariate regressions against Wold components of yields averaged across maturities');
% disp('(This is another way to DECOMPOSE THE LEVEL INTO ITS COMPONENTS');
% REGR=[ lvl_components_WOLD(1:end-12,:) PCAlevel_Wold(1:end-12,:) sum(PCAlevel_Wold(1:end-12,[1 2 3 4 5]),2)]; o = ones(T-12,1);
% numREGR=(1:size(REGR,2));
%    spec=[ ones(1,J+1)  zeros(1,J+1)                 0; ... %          lvl components (           Wold Components of average)
%          zeros(1,J+1)   ones(1,J+1)                 0; ... %          WOLD PCA       (average of Wold Components           )
%          zeros(1,J+1)   ones(1,  5) zeros(1,J+1-5)  0; ... % Selected WOLD PCA
%          zeros(1,J+1)   zeros(1,J+1)                1];    
% 
% for s=1:size(spec,1)
%   [betas,stbetas,R2,R2adj,v,F_trash]             = olsgmm(AHPRX,[o REGR(:,numREGR(spec(s,:)>0))],12,0);

% Average/L-S of Wold components
    selLVLcomponents = [1 2 3   5    ]; specLVL = zeros(1,J+1); specLVL(selLVLcomponents)=1;
            
    selSLOcomponents = [        5 6  ]; specSLO = zeros(1,J+1); specSLO(selSLOcomponents)=1;
%   selSLOcomponents = [    3   5 6 7]; specSLO = zeros(1,J+1); specSLO(selSLOcomponents)=1; %For shorter sample but actually worsen the result of the factor
%   selSLOcomponents = [    3   5 6 7]; specSLO = zeros(1,J+1); specSLO(selSLOcomponents)=1; %For shorter sample but actually worsen the result of the factor    

% *************************************************************************
disp('-----------------------------------------------------');
disp('Univariate regressions against Level and its components (Panel A, row a,b,c,d)');
% REGR=[lvl(1:end-12) lvl_components(   1:end-12,:) ]; o = ones(T-12,1);
  REGR=[lvl(1:end-12) L_components_WOLD(1:end-12,:) ]; o = ones(T-12,1);

numREGR=(1:size(REGR,2));
   spec=[1 zeros(1,J+1)    ; ... % lvl
         0 ones(1,J+1)     ; ... %          lvl components
         0 ones(1,J  )  0  ; ... %          lvl components BUT trend
         0 specLVL       ;]; ... % selected lvl components 
           
for s=1:size(spec,1)
  [betas,stbetas,R2,R2adj,v,F_trash]             = olsgmm(AHPRX,[o REGR(:,numREGR(spec(s,:)>0))],NWLags,NWvsHH); 


bv_xr  = betas'; if s==size(spec,1); LoadingLVL = bv_xr(2:end); end
tstat_xr=betas'./stbetas';
R2v_xr=R2adj;
mprint3(bv_xr,tstat_xr,[NaN(1,sum(spec(s,:))) R2v_xr'],info);
fprintf('\n\n')
end
clear betas stbetas R2 R2adj v F_trash bv_xr tstat_xr R2v_xr o spec REGR numREGR s

disp('-----------------------------------------------------');
disp('Univariate regressions against Slope and its components (Panel B, row a,b,c,d)');
% REGR=[slo(1:end-12,:) slo_components(   1:end-12,:)]; o = ones(T-12,1);
  REGR=[slo(1:end-12,:) S_components_WOLD(1:end-12,:)]; o = ones(T-12,1);

numREGR=(1:size(REGR,2));
   spec=[1 zeros(1,J+1)   ; ... % slo
         0 ones(1,J+1)    ; ... %          slo components
         0 ones(1,J  )  0 ;     %          slo components BUT trend
         0 specSLO        ;];   % selected slo components 
for s=1:size(spec,1)
  [betas,stbetas,R2,R2adj,v,F_trash]             = olsgmm(AHPRX,[o REGR(:,numREGR(spec(s,:)>0))],NWLags,NWvsHH); 

bv_xr  = betas'; if s==size(spec,1); LoadingSLO = bv_xr(2:end); end
tstat_xr=betas'./stbetas';
R2v_xr=R2adj;
mprint3(bv_xr,tstat_xr,[NaN(1,sum(spec(s,:))) R2v_xr'],info);
fprintf('\n\n')
end
clear betas stbetas R2 R2adj v F_trash bv_xr tstat_xr R2v_xr o spec REGR numREGR s

% *************************************************************************
disp('-----------------------------------------------------');
disp('Univariate regressions against Level and Slope Wold Factors (Panel A, row e AND Panel B, row e AND Panel C, row a, d, e)');
  REGR=[lvlC(1:end-12) sum(L_components_WOLD(1:end-12,selLVLcomponents),2) slo( 1:end-12) sum(S_components_WOLD(1:end-12,selSLOcomponents),2)]; o = ones(T-12,1);
% REGR=[lvlC(1:end-12) sum(L_components_WOLD(1:end-12,selLVLcomponents),2) sloC(1:end-12) sum(S_components_WOLD(1:end-12,selSLOcomponents),2)]; o = ones(T-12,1);
  
numREGR=(1:size(REGR,2));
   spec=[0 1 0 0 ; ... % Level         Cycle from WOLD
         0 0 0 1 ;     %         Slope Cycle from WOLD
         0 1 0 1 ;     % Level                         + Slope Cycle from WOLD
         1 1 0 0 ;     % Level: HORSE RACE
         1 0 1 0];     % Level               from CPo  + Slope from CPo

for s=1:size(spec,1)
  [betas,stbetas,~,R2adj]             = olsgmm(AHPRX,[o REGR(:,numREGR(spec(s,:)>0))],NWLags,NWvsHH); 

if s==3; betas_OSTT = betas; BP_OSTT = [ones(T,1) sum(L_components_WOLD(:,selLVLcomponents),2) sum(S_components_WOLD(:,selSLOcomponents),2)]*betas_OSTT; end 

bv_xr  = betas';
tstat_xr=betas'./stbetas';
  R2v_xr=R2adj;
% R2v_xr=R2;
mprint3(bv_xr,tstat_xr,[NaN(1,sum(spec(s,:))) R2v_xr'],info);
fprintf('\n\n')
if s==1; LoadingLVLrestricted = bv_xr(2:end); end
if s==2; LoadingSLOrestricted = bv_xr(2:end); end
if s==3 | s ==4
    disp('-----------------------------------------------------');
end
end
clear betas stbetas R2 R2adj v F_trash bv_xr tstat_xr R2v_xr o


fprintf('Correlation between Level Cycle from CPo  and Slope           %3.3f \n', corr(lvlC,slo))
fprintf('Correlation between Level Cycle from CPo  and Slope from Wold %3.3f \n', corr(lvlC                                        ,sum(S_components_WOLD(:,selSLOcomponents),2)))
fprintf('Correlation between Level Cycle from WOLD and Slope from Wold %3.3f \n', corr(sum(L_components_WOLD(:,selLVLcomponents),2),sum(S_components_WOLD(:,selSLOcomponents),2)))
% 

varLVLcomponents = var(lvl_components);
weightsLVL = varLVLcomponents(selLVLcomponents)/sum(varLVLcomponents(selLVLcomponents));
fprintf('Coefficint on slope reweighted by variance %3.3f vs restricted coefficient %3.3f\n',sum(weightsLVL.*LoadingLVL),LoadingLVLrestricted);

varSLOcomponents = var(slo_components);
weightsSLO = varSLOcomponents(selSLOcomponents)/sum(varSLOcomponents(selSLOcomponents));
fprintf('Coefficint on slope reweighted by variance %3.3f vs restricted coefficient %3.3f\n',sum(weightsSLO.*LoadingSLO),LoadingSLOrestricted);

% %% FIGURES
% % [Years,M] = meshgrid(1971:2016, 1:12);
% % calM = datenum([Years(:), M(:), 28*ones(numel(Years),1)]); % The Serial Dates
% 
% ticks = datenum([(1975:5:2018)', ones(9,1), ones(9,1) ]);
% lim_x =[datenum(  1971,30,09), datenum(2016,12,30)];
% 
% COLOR = linspecer(5); 
% LineWidth =  4.0;   